<?php

class Text extends Component
{
        // type of the component, used for output
        var $g_component_type;
        
        // title of a component instance, used for output
        var $g_component_title;
        
        // component's position in the exercise (beginning with 1!)
        var $g_component_position;
        
        // text content
        var $g_content;
        
        // constructor
        function Text()
        {
                $this->g_component_type = _("Text");
                $this->g_component_title = _("Aufgabentext");
                $this->g_component_position = 0;
        }
        
        
        
        
        
        // initialises the global variables using the DOM data representing this component
        function init_component($p_dom)
        {
                $this->g_component_title = $p_dom->get_attribute("title");
                $this->g_component_position = $p_dom->get_attribute("position");
                $text_node = $p_dom->first_child();
                $this->g_content = $text_node->node_value();
        }
        
        
        
        
        
        // generates the lecturer's view of the component (i.e. for generating and adjusting)
        function generate_component_edit()
        {
                global $vipsTemplateFactory;

                $tmpl = $vipsTemplateFactory->open('exercises/edit_text_component');
                
#               $tmpl->set_attribute("t_exercise_type", getExternalParam("exercise_type"));
#               $tmpl->set_attribute("t_exercise_id", getExternalParam("exercise_id"));
#               $tmpl->set_attribute("t_assignment_id", getExternalParam("assignment_id"));
#               $tmpl->set_attribute("t_action", getExternalParam("action"));
#               $tmpl->set_attribute("t_unfold", getExternalParam("unfold"));
                
                $tmpl->set_attribute("t_component_type", $this->g_component_type);
                $tmpl->set_attribute("t_component_title", $this->g_component_title);
                $tmpl->set_attribute("t_component_position", $this->g_component_position);
                $tmpl->set_attribute("t_content", $this->g_content);
                
                return $tmpl->render();
        }
        
        
        
        
        
        // generates the student's view of the component (i.e. for solving)
        function generate_component_show()
        {
                global $vipsTemplateFactory;

                $tmpl = $vipsTemplateFactory->open('exercises/show_edit_text_component');
                
                $tmpl->set_attribute("t_content");
                
                return $tmpl->render();
        }
        
        
        
        
        
        // generates XML representing the component
        function generate_XML() {}
        
}

?>
