<?php

require_once 'exercises/exercise.php';

// global table styles
#$g_table_style = array
#       ( "table"          => array("align" => "center", "style" => "width: 99%;")
#       , "row"            => array("class" => "steel1")
#       , "row_blank"      => array("class" => "blank")
#       , "row_small_font" => array("style" => "font-size: 12px;")
#       , "row_header"     => array
#               ( "class" => "steel"
#               , "style" => "font-size: smaller; font-weight: bold;")
#       , "cell"           => array("style" => "padding: 2px 5px;")
#       , "cell_edge"      => array("class" => "steel1kante", "style" => "height: 2px;")
#       );





/**
 * XXX detailed description
 *
 * @author    XXX
 * @copyright XXX
 * @abstract
 */
class mc_exercise extends Exercise {

        var $g_numberOfAnswers;
        var $g_ExerciseName = "Multiple Choice";
        var $g_ExerciseDescription = "DescriptionExerciseMC";
        var $g_maxPoints;


        function  mc_exercise() {
//              $this->g_numberOfAnswers                = 5;
//              $this->g_Action                                 = getExternalParam('action');
//              $this->g_OpenObject                     = 'openobject_'. strtolower($this->Action);
//              $this->g_maxPoints = $this->g_numberOfAnswers;
        }

        /**************************************************************************/
        /*
        /* Evaluates the solution
        /*
        /**************************************************************************/

   /**
        *    Evaluates a solution.
        *
        *    @abstract
        *    @access public
        *    @returns int (from 0 to 100 ) as an % value
        */

        function evaluate ($exercise,$solution) {
                $dom_xml = $this->getDomXML($exercise);
                $answers = $dom_xml->get_elements_by_tagname("Answer");
                $mc_auswertung = $dom_xml->get_elements_by_tagname("EvalMode");
                $punkte = 0;

                // in case there is a MC evaluation specification, get it. If not, default is 0 anyway.
                if ($mc_auswertung)
                    $mc_auswertung = $mc_auswertung[0]->get_content(); 
                
                $answer_array = array();
                $correct_array = array();
                
                foreach ($answers as $node) {
                        $answer_array[]         = html_ready(utf8_decode($node->get_content()));
                        $correct_array[]        = (int) $node->get_attribute("Correct");
                }

                $student_array = $this->getTagsFromXML($solution, "answer");

                for ($i = 0; $i < count($correct_array); $i++) {
                        if ($student_array[$i] == $correct_array[$i]) 
                                ++$punkte;
                        else if ($mc_auswertung == 1)
                                --$punkte;      // abzug bei falscher antwort
                }

                if ($punkte < 0) $punkte = 0;

                $m_prozent = $punkte / count($correct_array) * 100;
                $m_save = 1;
                
                $m_return[1] = $m_prozent;
                $m_return[2] = $m_save;
                $m_return[5] = $punkte;
                return $m_return;
        }

   /**
        * Generates generates an XML-String containing the solution of the
        * student.
        *
        * Gets ist values to be stored in the XML-String from the
        * Get/Post environment.
        *
        * @param int $exercise_id the id of the exercise the solution related to.
        * @param int $p_number_of_answers the number of answers possible (??? not a class variable, ES)
        * @return XML the XML-String containing the solutions of the student.
        *
        * @todo names of the exml entities are not well choosen. A change will have
        * impact on other parts of the code, of course.
        */

        function genSolution($p_exercise_id, $p_number_of_answers) {
                
                $i              = 0;
                $msg    = "<solution id=\"".$p_exercise_id."\">";
                
                while ($i < $p_number_of_answers)
                {

                        // the choosen answers are in the get or post environment: 1. Otherwise:0.
                        if(getExternalParam("answer_$i")) {
                                $msg .= "<answer id=\"".$i."\">";
                                $msg .= "<body><![CDATA[1]]></body>";
                                $msg .= "</answer>";
                        }
                        else {
                                $msg .= "<answer id=\"".$i."\">";
                                $msg .= "<body><![CDATA[0]]></body>";
                                $msg .= "</answer>";
                        } // end if
                        $i++;
                } // end while
                
                $msg.= "</solution>";
                return ($msg);
        }



  /**
   * Generate the description af an exercise in an XML-String.
   *
   * Gets ist values to be stored in the XML-String from the
   * Get/Post environment.
   *
   * @return XML the SML-String describing the exercise in terms of its
   * name, questions, worng and correct solutions etc.
   */

        function getExerciseConstruct() {

                /*************************************************************************/
                /* Get data
                /*************************************************************************/

                $m_exercise_language = "de";
                
                $m_exercise_type     = getExternalParam("exercise_type");
                $m_exercise_question = getExternalParam("exercise_question");
                $m_exercise_name     = getExternalParam("exercise_name");
                $m_exerciseHint      = getExternalParam("exercise_hint");
                $m_exercise_comment  = getExternalParam("exercise_comment");
                
                $m_exercise_pic_url  = getExternalParam("exercise_pic_url");  //??
                $m_provides          = getExternalParam("provides");  //??
                $m_depends           = getExternalParam("depends"); //??
                $m_optional_depends  = getExternalParam("optional_depends"); //??
                $m_number_of_answers = getExternalParam("number_of_answers");
                $m_mc_auswertung     = getExternalParam("mc_auswertung");
                
                $this->g_maxPoints = $m_number_of_answers;
                
                #$m_correct_answers   = getExternalParam("correct_answers") == "show"
                #                                                       ? "yes"
                #                                                       : "no";

                $i = 0;
                do {
                        $correct_array[$i] = getExternalParam("correct_".$i);
                        $answer_array[$i]  = getExternalParam("answer_".$i);
                        $i++;
                } while ($i < $m_number_of_answers);

                /*************************************************************************/
                /* Construct XML
                /*************************************************************************/

                $xmlop  = "<TestItem ID=\"" . $m_exercise_type . "\" Type=\"MultipleChoice\" Language=\"" . $m_exercise_language . "\">";
                $xmlop .= "<Name><![CDATA[" . $m_exercise_name . "]]></Name>";
                $xmlop .= "<Hint><![CDATA[" . $m_exerciseHint . "]]></Hint>";
                $xmlop .= "<CommentField Visible=\"".$m_exercise_comment."\"></CommentField>";
                // $xmlop .= "<CorrectAnswers Visible=\"".$m_correct_answers."\"></CorrectAnswers>";
                $xmlop .= "<PictureURL><![CDATA[" . $m_exercise_pic_url . "]]></PictureURL>";
                $xmlop .= "<Provides><![CDATA[". $m_provides . "]]></Provides>";
                $xmlop .= "<Depends><![CDATA[". $m_depends . "]]></Depends>";
                $xmlop .= "<OptionalDepends><![CDATA[". $m_optional_depends . "]]></OptionalDepends>";
                $xmlop .= "<Question>";
                $xmlop .= "<Paragraph><![CDATA[" .$m_exercise_question. "]]></Paragraph>";
                $xmlop .= "</Question>";
                $xmlop .= "<EvalMode><![CDATA[". $m_mc_auswertung . "]]></EvalMode>";

                for ($i=0;$i < count($answer_array);$i++) {
                        if ($answer_array[$i])                                          //store only meaningful answers
                        $xmlop.='<Answer Correct="'.$correct_array[$i].'"><![CDATA['
                                        .$answer_array[$i]
                                        .']]></Answer>';
                }

                $xmlop .= "</TestItem>";
                
                /*************************************************************************/
                /* Return XML
                /*************************************************************************/

                return ($xmlop);
        }
}
?>
