<?php

/**
 * Created on 08.03.2006 by Christa Deiwiks <cdeiwiks@uos.de>
 * 13:49:06
 * 
 * Manages Vips-related info concerning administration:
 * 
 * - access parameters
 * - sheet weightings
 * - grade distribution
 * 
 * @author: Christa Deiwiks <cdeiwiks@uos.de>
 */

function vips_admin($p_subaction) {
        if ($p_subaction == 'main')   { 
                main();
        }
        elseif ($p_subaction == 'store_access') {
                store_access();
        }
        elseif ($p_subaction == 'store_distribution') {
                store_distribution();
        }
        elseif ($p_subaction == 'store_parameters') {
                store_parameters();
        }
        elseif ($p_subaction == 'delete_group') {               //Klausur-Gruppierung aufloesen
                delete_group();
        }
        elseif ($p_subaction == 'view_student_data') {  //detaillierte Auflistung aller Uebungsblaetter/Klausuren fuer einen Studenten
                view_student_data();
        }
        else main();
}

/**
 * TODO?
 * Detailed listing of all blocks, sheets and exams for one student (similar to solution view)
 */
function view_student_data() {
        $item_type = getExternalParam('item_type');
        $item_id = getExternalParam('item_id');
        
        if ($item_type == 'sheets') {
                $_POST['assignment_type'] = "vips_uebungsblatt";
                $_POST['assignment_id'] = $item_id;

                //require_once("vips_solutions.inc.php");
                //vips_solutions('show_assignment_solutions');
                
        }
        elseif ($item_type = 'exams') {
                $_POST['assignment_type'] = "vips_klausur";
                $_POST['assignment_id'] = $item_id;
                require_once('vips_solutions.inc.php');
                vips_solutions('show_assignment_solutions');
        }
        //TODO:
                /*
                $query = "SELECT *
                        FROM vips_uebungsblatt
                        WHERE ID = $item_id
                        ";
                $result = $vips_db->executeQuery($query);
                $result->next();
                $sheet = $result->getRow();
        
                ##########################################################
                # get all exercises, max points and user solution points #
        
                $query = "SELECT DISTINCT
                        vips_inUebungsblatt.vips_aufgabe
                        , vips_aufgabe.Name
                        , vips_inUebungsblatt.Punkte
                        , vips_inUebungsblatt.Position
                FROM
                        vips_inUebungsblatt
                        , `vips_aufgabe`
                WHERE
                        vips_inUebungsblatt.vips_uebungsblatt = '$item_id'
                        AND vips_aufgabe.ID = vips_inUebungsblatt.vips_aufgabe
                ORDER BY
                        vips_inUebungsblatt.Position
                ";
                $result = $vips_db->executeQuery($query);
        
                $points_sheet = 0;
                $exercises = array();
                while ($result->next())
                {       
                        $entry = $result->getRow();
                        $exercises[] = $entry;
                        $points_sheet += $entry["Punkte"];
                }
        //get all exercises and solutions
        //wie in Loesungen
        }*/

}

/**
 * Undoes a grouping of two exams
 */

function delete_group() {
        global $vips_db, $g_outlet;

        $group_id = getExternalParam('group_id');
        $vips_db->executeUpdate("DELETE FROM vips_klausur_gruppierung
                                                  WHERE id = '$group_id'");
        $vips_db->executeUpdate("DELETE FROM vips_gewichtung
                                                WHERE Item_id = '$group_id'
                                                AND Item_type = 'groups'");                     
        main();
        
}



/**
 * 
 * Stores the weights and exam grouping of blocks,sheets and exams 
 * 
 */

function store_parameters() {
        global $vips_db, $g_outlet;
        
        $number_of_blocks = getExternalParam("number_of_blocks");
        $number_of_exams  = getExternalParam("number_of_exams");
        $number_of_sheets = getExternalParam("number_of_sheets");
        $number_of_groups = getExternalParam("number_of_groups");
        
        $gruppierung = $_POST['gruppierung'];
        $anzahl_gruppierte_klausuren = count($gruppierung);
        $weight_gruppierte_klausuren = array();
        
        $prozente       = 0;
        $message = array();
        
        $bestehen = 0;
        
        for($i=0; $i<$number_of_blocks; $i++) {
                $prozente += getExternalParam("block_weight_$i");
        }
        for($i=0; $i<$number_of_exams; $i++) {
                $prozente += getExternalParam("exams_weight_$i");
                if (($bestehen_temp = getExternalParam("exams_bestehen_$i")) > $bestehen) 
                        $bestehen = $bestehen_temp;
        }
        for($i=0; $i<$number_of_sheets; $i++) {
                $prozente += getExternalParam("sheets_weight_$i");
        }
        for($i=0; $i<$number_of_groups; $i++) {
                $prozente += getExternalParam("groups_weight_$i");
        }
        
        foreach($gruppierung as $counter=>$klausur_id) {
                $weight_gruppierte_klausuren[] = getExternalParam("exams_weight_$counter");
        }
        
        
        if ($prozente != 100 && $prozente) {
                $message['mode']        = 'neg';
                $message['message'] = "Die Gewichtungen m&uuml;ssen in der Summe 100 oder 0 (keine Gewichtung) ergeben. Die Daten wurden nicht &uuml;bernommen!";       
        }
        elseif ($bestehen > 100) {
                $message['mode']        = 'neg';
                $message['message'] = "Die Prozentwerte zum Bestehen m&uuml;ssen kleiner oder gleich 100 sein. Die Daten wurden nicht &uuml;bernommen!";        
        }
        elseif ($anzahl_gruppierte_klausuren && $anzahl_gruppierte_klausuren !=2) {
                $message['mode']        = 'neg';
                $message['message'] = "Zum Gruppieren bitte genau 2 Klausuren markieren!";      
        }
        else {
                for($i=0; $i<$number_of_blocks; $i++) {
                        $id             = getExternalParam("block_id_$i");
                        $weight = getExternalParam("block_weight_$i");  
                        $sql = "REPLACE vips_gewichtung
                                        SET Gewichtung = '$weight',
                                        Item_id = '$id',
                                        Item_type = 'blocks'";
                        $vips_db->executeUpdate($sql);
                }
                for($i=0; $i<$number_of_exams; $i++) {
                        $id             = getExternalParam("exams_id_$i");
                        $weight = getExternalParam("exams_weight_$i");  
                        $sql = "REPLACE vips_gewichtung
                                        SET Gewichtung = '$weight',
                                        Item_id = '$id',
                                        Item_type = 'exams'";
                        $vips_db->executeUpdate($sql);
                        
                        $bestehen = getExternalParam("exams_bestehen_$i");      
                        $sql = "UPDATE vips_klausur
                                        SET Bestehen = '$bestehen'
                                        WHERE ID = '$id'";
                        $vips_db->executeUpdate($sql);
                        
                }
                for($i=0; $i<$number_of_sheets; $i++) {
                        $id             = getExternalParam("sheets_id_$i");
                        $weight = getExternalParam("sheets_weight_$i"); 
                        $sql = "REPLACE vips_gewichtung
                                        SET Gewichtung = '$weight',
                                        Item_id = '$id',
                                        Item_type = 'sheets'";
                        $vips_db->executeUpdate($sql);
                }
                
                for($i=0; $i<$number_of_groups; $i++) {
                        $id             = getExternalParam("groups_id_$i");
                        $weight = getExternalParam("groups_weight_$i"); 
                        $sql = "REPLACE vips_gewichtung
                                        SET Gewichtung = '$weight',
                                        Item_id = '$id',
                                        Item_type = 'groups'";
                        $vips_db->executeUpdate($sql);
                        
                        $fail_k1                = getExternalParam("fail_k1_$i");
                        $pass_k1                = getExternalParam("pass_k1_$i");
                
                        $vips_db->executeUpdate("UPDATE vips_klausur_gruppierung
                                        SET fail_k1 = '$fail_k1',
                                                pass_k1 = '$pass_k1'
                                        WHERE id = '$id'
                                        ");
                        
                }
                
                if ($anzahl_gruppierte_klausuren == 2) {   //if two exams are to be grouped
                        $kurs_id = $g_outlet->courseID;
                        $k1 = $gruppierung[0];
                        $k2 = $gruppierung[1];  
                        $weight_k1 = $weight_gruppierte_klausuren[0];
                        $sql = "INSERT INTO vips_klausur_gruppierung
                                        SET k1 = '$k1',
                                            k2 = '$k2',
                                            kurs = '$kurs_id'";
                        $vips_db->executeUpdate($sql);
                        $vips_idgen = $vips_db->getIdGenerator();
                        $weight_id = $vips_idgen->getId();              
                        $sql = "INSERT INTO vips_gewichtung
                                        SET Gewichtung = '$weight_k1',
                                            Item_id = $weight_id,
                                            Item_type = 'groups'";
                        $vips_db->executeUpdate($sql);
                        
                        $message['mode']        = 'pos';
                        $message['message'] = "Die Klausuren wurden gruppiert! <font style=color:red>Bitte &uuml;berarbeiten Sie jetzt ggf. die Gewichtungen!</font>";  
                }       
        }
        
        $_POST['message']       = $message;
        main();
}

/**
 * 
 * Stores the distribution of grades 
 * 
 */
function store_distribution() {
        global $vips_db, $g_outlet;
        
        $message        = array();
        $error          = false;
        
        $grades          = array("1,0" , "1,3", "1,7", "2,0", "2,3", "2,7", "3,0", "3,3", "3,7", "4,0");
        $percentages = array();
        $comments = array();
        
        for($i=0; $i < 10; $i++)  {
                $percentages[] = getExternalParam("percentage_".$i);
                $comments[] = getExternalParam("comment_".$i);
        }
        
        ######################
        #  check percentage  #
        ######################
        
        $percentage_last = '101';
        
        for($i=0; $i < 10; $i++)  {
                if ($percentages[$i] < 0 || $percentages[$i] > 100) {
                        $message['mode']        = 'neg';
                        $message['message'] = "Die Notenwerte m&uuml;ssen zwischen 0 und 100 liegen!";  
                        $error = true;
                }
                elseif ($percentage_last <= $percentages[$i]) {
                        $message['mode']        = 'neg';
                        $message['message'] = "Die Notenwerte m&uuml;ssen monoton absteigen ( $percentages[$i] >= $percentage_last )!"; 
                        $error = true;
                }
                
                $percentage_last = $percentages[$i];    
        }
        
        ###########################
        #  insert/update database #
        ###########################
        
        if (!$error) {
                for ($i=0; $i < 10; $i++)  {
                        $percentage = $percentages[$i];
                        $comment = $comments[$i];
                        $grade  = $grades[$i];
                        $result = $vips_db->executeQuery("SELECT * FROM vips_noten WHERE Note = '$grade' AND Kurs = '$g_outlet->courseID'");
                        if ($result->getRecordCount()!=0) {
                                $vips_db->executeUpdate("UPDATE vips_noten
                                                                SET 
                                                                        Prozent = '$percentage',
                                                                        comment = '$comment'
                                                                WHERE
                                                                        Note    = '$grade'
                                                                AND
                                                                        Kurs    = '$g_outlet->courseID'
                                                        ");
                        
                        }
                        else {
                                $vips_db->executeUpdate("INSERT INTO vips_noten
                                                                SET 
                                                                        Prozent = '$percentage',
                                                                        Note    = '$grade',
                                                                        Kurs    = '$g_outlet->courseID',
                                                                        comment = '$comment'
                                                        ");
                                /*
                                 doesn't work with MySQL 4.0 at RZ
                                $vips_db->executeUpdate("INSERT INTO vips_noten
                                                                SET 
                                                                        Prozent = '$percentage',
                                                                        Note    = '$grade',
                                                                        Kurs    = '$g_outlet->courseID'
                                                        ON DUPLICATE KEY UPDATE
                                                                        Prozent = '$percentage'
                                                        "); */
                        }
                }
                $message['mode']        = 'pos';
                $message['message'] = "Die Notenwerte wurden eingetragen!";     
        }
        
        $_POST['message'] = $message;
        main();
}

/**
 *  
 * Displays the main page with
 * -access info
 * -evaluation parameters
 * -grade distribution
 * to edit
 * 
 */
function main() {
        global $vips_db, $g_outlet, $vipsTemplateFactory;
        
        $t_main = $vipsTemplateFactory->open('admin_main');

        $t_main->set_attributes(array(
                'buttonpath'  => $g_outlet->buttonpath,
                'picturepath' => $g_outlet->picturepath,
                'status'          => $g_outlet->status));                                       

#######################################
############# ACCESS ##################
#######################################

        $options = array();
        
        $result = $vips_db->executeQuery("SELECT * FROM vips_optionen
                                                 WHERE Kursid = '$g_outlet->courseID'");   //wann wird da was reingeschrieben??? erst bei store_options()
        
        if ($result->next()) {
                $entry = $result->getRow();
                if ($entry['Selbstzuweisung'])  $options[0] = 'checked="checked"';
                if ($entry['Tutor'])                    $options[1] = 'checked="checked"';
                //if ($entry['Testbetrieb'])            $options[1] = 'checked="checked"';
                //if ($entry['leereloesungen'])         $options[3] = 'checked="checked"';
        }
        $t_main->set_attribute('options', $options);


###########################################
############# PARAMETERS ##################
###########################################

        $message                        = $_POST['message'];
        $dialog                         = getExternalParam('dialog');
        $delete_block_name      = getExternalParam('delete_block_name');
        
        #####################################
        # get used blocks and their weights #
        #####################################
        
        $blocks = array();

        $result = $vips_db->executeQuery("SELECT DISTINCT * FROM vips_block
                                                  WHERE Kurs = '$g_outlet->courseID'");
        while ($result->next()) {
                $entry = $result->getRow();
                $block_id = $entry['id'];
                $result2 = $vips_db->executeQuery(
                                "SELECT * 
                                FROM vips_gewichtung 
                                WHERE Item_id = '$block_id'
                                AND Item_type = 'blocks'");
                if ($result2->next()) {
                        $weight = $result2->getRow();
                        $entry['weight'] = $weight['Gewichtung'];
                }
                $result2 = $vips_db->executeQuery("SELECT * FROM vips_inBlock WHERE block_id = '$block_id'");
                if ($result2->getRecordCount())
                        $blocks[] = $entry;
        }
        
        #############################################################
        # ... and remaining assignments and groups and their data   #
        #############################################################
        
        $sheets = array();
        $query = "SELECT * FROM vips_uebungsblatt
                        WHERE Kurs='$g_outlet->courseID'
                        ORDER BY Beginn, Position";
        $result = $vips_db->executeQuery($query);
        while ($result->next()) {
                $entry = $result->getRow();
                $assignment_id = $entry['ID'];
                $result2 = $vips_db->executeQuery(
                                "SELECT * 
                                FROM vips_gewichtung 
                                WHERE Item_id = '$assignment_id'
                                AND Item_type = 'sheets'");
                if ($result2->next()) {
                        $weight = $result2->getRow();
                        $entry['weight'] = $weight['Gewichtung'];
                }       
                $result2 = $vips_db->executeQuery("SELECT * FROM vips_inBlock WHERE assignment_id = '$assignment_id'");
                if ($result2->getRecordCount()==0)
                        $sheets[] = $entry;
        }
        
        
        $groups = array();
        $query = "SELECT * FROM vips_klausur_gruppierung
                        WHERE kurs='$g_outlet->courseID'
                        ";
        $result = $vips_db->executeQuery($query);
        while ($result->next()) {
                $entry = $result->getRow();
                $group_id = $entry['id'];
                $k1 = $entry['k1'];
                $k2 = $entry['k2'];
                $result2 = $vips_db->executeQuery("SELECT * FROM vips_klausur WHERE ID = '$k1'");
                $result2->next();
                $entry2 = $result2->getRow();
                $entry['k1_name'] = $entry2['Name'];
                $result2 = $vips_db->executeQuery("SELECT Name FROM vips_klausur WHERE ID = '$k2'");
                $result2->next();
                $entry2 = $result2->getRow();
                $entry['k2_name'] = $entry2['Name'];
                $result2 = $vips_db->executeQuery(
                                "SELECT * 
                                FROM vips_gewichtung 
                                WHERE Item_id = '$group_id'
                                AND Item_type = 'groups'");
                if ($result2->next()) {
                        $weight = $result2->getRow();
                        $entry['weight'] = $weight['Gewichtung'];
                }
                $groups[] = $entry;
        }
        
        $exams = array();
        $query = "SELECT * FROM vips_klausur
                        WHERE Kurs='$g_outlet->courseID'
                        ORDER BY Beginn, Position";
        $result = $vips_db->executeQuery($query);
        while ($result->next()) {
                $entry = $result->getRow();
                $assignment_id = $entry['ID'];
                $result2 = $vips_db->executeQuery(
                                "SELECT * 
                                FROM vips_gewichtung 
                                WHERE Item_id = '$assignment_id'
                                AND Item_type = 'exams'");
                if ($result2->next()) {
                        $weight = $result2->getRow();
                        $entry['weight'] = $weight['Gewichtung'];
                }
                $result2 = $vips_db->executeQuery("SELECT * FROM vips_klausur_gruppierung WHERE k1 = '$assignment_id' OR k2 = '$assignment_id'");
                if ($result2->getRecordCount()==0)
                        $exams[] = $entry;
        }

        $t_main->set_attribute('blocks', $blocks);
        $t_main->set_attribute('exams',  $exams);
        $t_main->set_attribute('sheets', $sheets);
        $t_main->set_attribute('groups', $groups);
        
###########################################
############# DISTRIBUTION ################
###########################################
        
        $grades = array("1,0" , "1,3", "1,7", "2,0", "2,3", "2,7", "3,0", "3,3", "3,7", "4,0");
        $percentages = array();
        $comments = array();
        $result = $vips_db->executeQuery ("SELECT Prozent, comment FROM vips_noten
                                                        WHERE Kurs = '$g_outlet->courseID'
                                                        ORDER BY Note");
        while ($result->next()) {
                $percentage = $result->getRow();
                $percentages[] = $percentage['Prozent'];
                $comments[] = $percentage['comment'];
        }
        if (count($percentages)==0) {
                $percentages = array("80", "75", "70", "65", "60", "55", "50", "45", "40", "35");
        }
        
        $t_main->set_attributes(array(
                'message'         => $message,
                'dialog'          => $dialog,
                'delete_block_name' => $delete_block_name));    
        
        $t_main->set_attribute('grades', $grades);
        $t_main->set_attribute('percentages', $percentages);
        $t_main->set_attribute('comments', $comments);
///////////////////////////////////////////////////////////

        echo $t_main->render();
}


/**
 * 
 * Stores student and tutor access to different areas
 * TODO: Expandable, since there are only two options at the moment
 * 
 */


function store_access() {
        global $vips_db, $g_outlet;
        
        $options = $_POST['options'];

//ON DUPLICATE KEY UPDATE doesn't work with MySQL 4.0...

/*'$sql = "INSERT INTO vips_optionen
                                        SET 
                                                Kursid = '$g_outlet->courseID',
                                                Selbstzuweisung = '$options[0]',
                                                Testbetrieb     = '$options[1]',
                                                Tutor                   = '$options[2]',
                                                Loesunganzeigen = '$options[3]',
                                                leereloesungen  = '$options[4]'
                                        ON DUPLICATE KEY UPDATE
                                                Selbstzuweisung = '$options[0]',
                                                Testbetrieb     = '$options[1]',
                                                Tutor                   = '$options[2]',
                                                Loesunganzeigen = '$options[3]',
                                                leereloesungen  = '$options[4]'
                                ";
        echo $sql;
        $vips_db->executeUpdate($sql);*/
                                
        $result = $vips_db->executeQuery("SELECT * FROM vips_optionen WHERE Kursid = '$g_outlet->courseID'");
                
        if ($result->getRecordCount()!=0)        {
                        $vips_db->executeUpdate("UPDATE vips_optionen
                                        SET Selbstzuweisung = '$options[0]',
                                                Tutor                   = '$options[1]'
                                        WHERE Kursid = '$g_outlet->courseID'");
        } else
                        $vips_db->executeUpdate("INSERT INTO vips_optionen
                                        SET 
                                                Kursid = '$g_outlet->courseID',
                                                Selbstzuweisung = '$options[0]',
                                                Tutor                   = '$options[1]'
                                        ");
        main();
}
?>
