<?php

/**
 * 
 * Handles import of txt files with exercises to make it easier for the
 * user to create assignments. The syntax of the txt file is specified on the import main page
 * 
 * @author: Christa Deiwiks <cdeiwiks@uos.de>
 */

global $g_outlet;

function vips_import($p_subaction) {
        if ($p_subaction == 'main')   { 
                main();
        }
        elseif ($p_subaction == 'import')   { 
                import();
        }
        else {
                main();
        }
}


/**
 * 
 * Displays import main page
 * 
 */

function main() {
        global $g_outlet, $vipsTemplateFactory;
                
        $message = $_POST['message'];   
        $t_main = $vipsTemplateFactory->open('import_main');

        $t_main->set_attributes(array(
                'buttonpath'  => $g_outlet->buttonpath,
                'picturepath' => $g_outlet->picturepath,
                'status'          => $g_outlet->status,
                'message'         => $message));                                        
                
        echo $t_main->render();
}

/**
 * 
 * Import function.
 * 
 */

function import()    {
        global $vips_db,
                   $g_outlet,
                   $g_assignment_table,
                   $g_inAssignment_table;
                   
        $exercise_position      = 1;
        $error = false;
        $dauer = 0;     

        if (getExternalParam('import_sheet') || getExternalParam('import_sheet_x') != '') {     
                $g_assignment_table     = 'vips_uebungsblatt';
                $g_inAssignment_table   = 'vips_inUebungsblatt';
                $dauer = 10080;                 //default:one week;
        }
        else {  //import_exam
                $g_assignment_table     = 'vips_klausur';
                $g_inAssignment_table   = 'vips_inKlausur';
                $dauer = 120;                           //default:2hrs;
        }

        if (is_uploaded_file($_FILES['userfile']['tmp_name']))
        {
                $m_fh = fopen($_FILES['userfile']['tmp_name'], "r");
                $i = 0;
                while (!feof($m_fh))
                {
                        $my_input[$i] = fgets($m_fh);
                        $i++;
                }
                fclose($m_fh);
        }
        else
        {
                echo _("M&ouml;glicherweise trat ein Fehler beim Hochladen der Datei auf.");
                $error = true;
        }
        
        $j = 0;
                                
        #########################
        #  get rid of comments  #       
        #########################
                
        if (!$error) {
                for ($i = 0; $i < count($my_input); $i++)
                {
                        if (!preg_match('/^#/', $my_input[$i]))
                        {
                                $my_input2[$j] = $my_input[$i];
                                $j++;
                        }
                }
                unset($my_input);               
                $my_input = $my_input2;
                
                #####################
                # insert assignment #
                #####################
                                                
                $assignment_name = $_FILES['userfile']['name'];
                
                $now_t  = time() + 60 * 60;
                $now    = date("Y-m-d H:00:00", $now_t);        // unix timestamp
                $ende_t = $now_t + $dauer * 60;                 // + duration
                $ende = date("Y-m-d H:00:00", $ende_t);
                
                $vips_db->executeUpdate("INSERT INTO $g_assignment_table
                                        SET
                                                Name    = '$assignment_name',
                                                Beginn  = '$now',
                                                Ende    = '$ende',
                                                Dauer   = '$dauer',
                                                Kurs    = '$g_outlet->courseID'"); 
                                        
                $vips_idgen = $vips_db->getIdGenerator();
                $assignment_id = $vips_idgen->getId();          
        
        
        
        ###################################################
        #                                                 #
        #   P A R S I N G   T H E   W H O L E   F I L E   #
        #                                                 #
        ###################################################
        
                for ($i = 0; $i < count($my_input); $i++)
                {
                        $exercise_name          = "";
                        $exercise_type          = "";
                        $exercise_question      = "";
                        $exercise_hint          = "";
                        $exercise_pic_url       = "";
                        
                        $exercise_max_points= 1;
                        
                        $answer_counter = 0;
                        
        // echo "<br/><b>now parsing line $i:</b> ".$my_input[$i];
        
                        #########################
                        #     exercise name             #       
                        #########################       
                        
                        if (preg_match('/^Name:/', $my_input[$i])) {
                                list($m_split, $m_name) = split(":", $my_input[$i], 2);
                                $i++;
                        }
                        else { 
                                $m_name = $_FILES['userfile']['name']." Aufgabe ".$exercise_position;
                        }                       
                        $exercise_name = trim($m_name);         
                                
                        #########################
                        #     exercise type             #       
                        #########################       
                        
                        if (preg_match("/^SCO-Frage/",$my_input[$i])) {
                                $exercise_type = "sco_exercise";
                        }
                        elseif (preg_match("/^SC-Frage/",$my_input[$i]) ){
                                $exercise_type = "sc_exercise";
                        }
                        elseif (preg_match("/^JN-Frage/",$my_input[$i]) ){
                                $exercise_type = "yn_exercise";         
                        }                       
                        elseif (preg_match("/^MC-Frage/",$my_input[$i])) {
                                $exercise_type = "mc_exercise";
                        }
                        elseif (preg_match("/^MCO-Frage/",$my_input[$i]) ){
                                $exercise_type = "mco_exercise";        
                        }
                        elseif (preg_match("/^Frage/",$my_input[$i]) ){
                                $exercise_type = "lt_exercise"; 
                        }               
                        elseif (preg_match("/^PL-Frage/",$my_input[$i])) {
                                $exercise_type = "pl_exercise";
                        }
                        elseif (preg_match("/^OC-Frage/",$my_input[$i]) ){
                                $exercise_type = "oc_exercise"; 
                        }
                        elseif (preg_match("/^OCT-Frage/",$my_input[$i]) ){
                                $exercise_type = "oct_exercise";
                        }       
                        elseif (preg_match("/^Offene Frage/",$my_input[$i]) ){
                                $exercise_type = "tb_exercise";         
                        }
            elseif (preg_match('/^RH-Frage/', $my_input[$i]))  {
                $exercise_type = 'rh_exercise';
            }
                        else {
                            // skip empty line or unknown tag
                            continue;
                        }
                                
                        require_once("exercises/$exercise_type.php");
                        
                        #########################
                        #   exercise question   #       
                        #########################                               
                                                
                        list($m_typ, $m_frage) = split(":", $my_input[$i],2);
                        $i++;
                        while (!preg_match("/^Tipp:/", $my_input[$i])
                                && !preg_match("/^Grafik:/", $my_input[$i])
                                && !preg_match("/^Antwort:/", $my_input[$i])
                                && !preg_match("/^\+Antwort:/", $my_input[$i])
                                && !preg_match("/^Name:/", $my_input[$i])
                && !preg_match('/^Vorgabe:/', $my_input[$i])  // for rh
                                )
                        {
                                $m_frage .= $my_input[$i];
                                $i++;
                        }
                        $exercise_question = trim($m_frage);
                        
                        ##########
                        #  Tipp  #
                        ##########
                        
                        if (preg_match('/^Tipp:/', $my_input[$i])) {
                                list($m_tag, $m_tipp) = split(':', $my_input[$i], 2);
                                $i++;
                                while (!preg_match('/^\\\\Tipp/', $my_input[$i]))
                                {
                                        $m_tipp .= $my_input[$i];
                                        $i++;
                                }
                                $exercise_hint = trim($m_tipp);
                                $i++;
                        }
                                        
                        #########################
                        #   exercise pic url    #       
                        #########################
                        
                        if (preg_match('^Grafik:/', $my_input[$i])) {
                                list($m_typ, $m_grafik) = split(":", $my_input[$i],2);
                                $exercise_pic_url = $m_grafik;
                                $i++;
                        }

        /*****************  Single Choice oder J/N-Frage *******************/
                        if (    $exercise_type == 'sc_exercise' 
                                ||      $exercise_type == 'sco_exercise' 
                                ||      $exercise_type == 'yn_exercise' )
                        {                               
                                while (preg_match('/^\+Antwort/', $my_input[$i])
                                        || preg_match('/^Antwort/', $my_input[$i])
                                        )
                                {
                                        if(preg_match('/^\+Antwort/',$my_input[$i])) {
                                                $_POST["correct_0"] = "$answer_counter";
                                        }
                                        list($m_tag, $m_antwort) = split(":",  $my_input[$i],2);
                                        $i++;
                                        while(!preg_match("/^\+Antwort/",$my_input[$i])
                                                && !preg_match("/^Antwort/",$my_input[$i])
                                                && !preg_match("/^Name/",$my_input[$i])
                                                && !preg_match("/Frage:/",$my_input[$i])
                                                && !$i >= count($my_input))
                                        {
                                                $m_antwort .= $my_input[$i];
                                                $i++;
                                        }
                                        if ($exercise_type == 'yn_exercise') {
                                                $_POST["answer_$answer_counter"] = $m_antwort;
                                        } else {
                                                $_POST["answer_0_$answer_counter"] = $m_antwort;
                                        }
                                        $answer_counter++;
                                }
                                //$i--;                         
                        }
                                                
        /***************** MC, MCO, LT ****************/
                        elseif (        $exercise_type == 'mc_exercise' 
                                        ||      $exercise_type == 'mco_exercise' 
                                        ||      $exercise_type == 'lt_exercise' )
                        {       
                                while(preg_match('/^\+Antwort/',$my_input[$i])
                                        || preg_match('/^Antwort/',$my_input[$i]))
                                {
                                        if(preg_match("/^\+Antwort/",$my_input[$i])) {
                                                $_POST["correct_$answer_counter"] = '1';
                                        }
                                        else    $_POST["correct_$answer_counter"] = '0';
                                                        
                                        list($m_tag, $m_antwort) = split(":",  $my_input[$i],2);
                                        $i++;
                                        while(!preg_match("/^\+Antwort/",$my_input[$i])
                                                && !preg_match("/^Antwort/",$my_input[$i])
                                                && !preg_match("/^Name/",$my_input[$i])
                                                && !preg_match("/Frage:/",$my_input[$i])
                                                && !$i >= count($my_input))
                                        {
                                                $m_antwort .= $my_input[$i];
                                                $i++;
                                        }
                                        $_POST["answer_$answer_counter"] =  trim($m_antwort);
                                        $answer_counter++;
                                }
                                //$i--;
                                $exercise_max_points = $answer_counter;
                        }
                                                
                                                
        /***************** PL, OC, OCT, Offene Frage ************************/
                        elseif ($exercise_type == 'pl_exercise' 
                                ||$exercise_type == 'oc_exercise' 
                                ||$exercise_type == 'oct_exercise' 
                                ||$exercise_type == 'tb_exercise')
                        {
                                if (preg_match('/^Antwort:/', $my_input[$i])) {
                                        list($m_typ, $m_antwort) = split(":",  $my_input[$i], 2);
                                        $_POST["correct_0"] = '1';                        
                                        $i++;
                                                                
                                        while (!preg_match('/^\\\\Antwort/', $my_input[$i]))    {
                                                // echo "<br/><b>in Antwort : now parsing line $i:</b> ".$my_input[$i];
                                                $m_antwort .= $my_input[$i];
                                                $i++;
                                                
                                        }
                                        
                                        $_POST["answer_0"] = trim($m_antwort);
                                        $i++;   
                                }                               
                                //$i--; 
                        }
            
            
            
            /********************* Reihenfolge *********************/
            else if ($exercise_type == 'rh_exercise')
            {
                $hits = array();
                
                while (preg_match('/^(Vorgabe:)(.*)/', $my_input[$i], $hits))
                {
                    // $hits == array(0 => whole line, 1 => "Vorgabe:", 2 => rest) //
                    $_POST["default_$answer_counter"] = trim($hits[2]);
                    $i++;
                    
                    preg_match('/^(Antwort:)(.*)/', $my_input[$i], $hits);
                    $_POST["answer_$answer_counter"] = trim($hits[2]);
                    $_POST["default_to_answer_$answer_counter"] = "$answer_counter";

                    $i++;
                    $answer_counter++;  // determines $_POST['number_of_answers'] below
                }
            }
            
            
            
                        ################################
                        #  write exercise to database  #
                        ################################
                                                        
                        if ($exercise_type) {                                           
                                $m_Oclass = new $exercise_type();
                                                                
                                $_POST['exercise_type']     = $exercise_type;
                                $_POST['exercise_question'] = $exercise_question;
                                $_POST['exercise_name']     = $exercise_name;
                                $_POST['exercise_hint']     = $exercise_hint;
                                $_POST['exercise_pic_url']  = $exercise_pic_url;
                                $_POST['number_of_answers'] = "$answer_counter";
                                
                                $m_exerciseXML =  $m_Oclass->getExerciseConstruct();
                // use addslashes for XML: special characters (as "'") might occur;
                // wouldn't work in a mysql query
                
                // mix answers in Reihenfolge exercise
                if ($exercise_type == 'rh_exercise')
                {
                    $m_exerciseXML = $m_Oclass->mix_answers($m_exerciseXML);
                }
                
                                /*echo "<br><b>Importiert: ";
                                echo "Aufgabe ".$exercise_position." - \"".$exercise_name."\"</b>";
                                echo "<br>Typ: ".$exercise_type;
                                echo "<br>Frage: ".$exercise_question;*/
                                                
                                $query = "INSERT INTO vips_aufgabe
                                                        SET Name        = '$exercise_name',
                                                                Aufgabe = '".addslashes($m_exerciseXML)."',
                                                                URI             = '$exercise_type',
                                                                Userid  = '$g_outlet->userID'";
                                $vips_db->executeUpdate($query);
                                                
                                $vips_idgen = $vips_db->getIdGenerator();
                                $exercise_id    = $vips_idgen->getId();
        
                                $query = "INSERT INTO $g_inAssignment_table
                                                SET vips_aufgabe                = '$exercise_id'
                                                ,       $g_assignment_table     = '$assignment_id'
                                                ,       Punkte                          = '$exercise_max_points' 
                                                ,       Position                        = '$exercise_position'
                                                ,       Bewertet                        = 't'";
                                $vips_db->executeUpdate($query);        
                                                        
                                $exercise_position++;
                                //$i++;    //blank line between exercises
                                unset($_POST);
                        }
                } // end: for all the input
        }       //end if no error
        $message = array();
        $message['message'] = 'Die Aufgaben wurden importiert. Bitte bearbeiten Sie jetzt die Grunddaten des &Uuml;bungsblattes/der Klausur!';
        $message['mode']    = 'pos';
        $_POST['message']   = $message;
        
        main();
} // end function import()      

?>
